<?php

/**
 * @file
 * Page callback.
 */

// Declare namespace usages with aliases.
use Drupal\oop_example_08\BusinessLogic\Common as Common08;
use Drupal\oop_example_08\BusinessLogic\Vehicle as Vehicle08;
use Drupal\oop_example_08\BusinessLogic\Vehicle\Car as Car08;
use Drupal\oop_example_08\BusinessLogic\Vehicle\Car\Toyota as Toyota08;
use Drupal\oop_example_08\BusinessLogic\Vehicle\Motorcycle as Motorcycle08;
use Drupal\oop_example_08\BusinessLogic\Fruit as Fruit08;

/**
 * Page callback.
 */
function oop_example_08_page() {

  $v = new Vehicle08\Vehicle();
  $message = $v->getDescription();
  $message .= '<br />';

  $v1 = new Car08\Car();
  $v1->color = "blue";
  $message .= $v1->getDescription();
  $message .= '<br />';

  $v2 = new Motorcycle08\Motorcycle();
  $v2->color = "green";
  $message .= $v2->getDescription();
  $message .= '<br />';

  $v3 = new Toyota08\ToyotaCamry();
  $v3->color = 'black';
  $message .= $v3->getDescription();
  $message .= '<br />';
  $message .= $v3->getDoorsDescription();
  $message .= '<br />';

  $v4 = new Toyota08\ToyotaYaris();
  $v4->color = 'yellow';
  $message .= $v4->getDescription();
  $message .= '<br />';
  $message .= $v4->getDoorsDescription();
  $message .= '<br />';

  $f1 = new Fruit08\Orange();
  $f2 = new Fruit08\Banana();

  $message .= _oop_example_08_color_output($f1);
  $message .= '<br />';
  $message .= _oop_example_08_color_output($v3);
  $message .= '<br />';
  $message .= _oop_example_08_color_output($f2);
  $message .= '<br />';

  return array(
    '#type' => 'markup',
    '#markup' => $message,
  );
}

/**
 * Returns color message.
 */
function _oop_example_08_color_output(Common08\ColorInterface $color_object) {
  $s = "This object has color " . $color_object->GetColor() . ".";
  return $s;
}
